#ifndef HAL_CONFIG_H
#define HAL_CONFIG_H

#include "em_device.h"
#include "hal-config-types.h"

// This file is auto-generated by Hardware Configurator in Simplicity Studio.
// Any content between $[ and ]$ will be replaced whenever the file is regenerated.
// Content outside these regions will be preserved.

// $[ACMP0]
// [ACMP0]$

// $[ACMP1]
// [ACMP1]$

// $[ANTDIV]
// [ANTDIV]$

// $[BTL_BUTTON]
// [BTL_BUTTON]$

// $[BUTTON]
#define BSP_BUTTON_PRESENT                            (1)

#define BSP_BUTTON0_PIN                               (0U)
#define BSP_BUTTON0_PORT                              (gpioPortB)

#define BSP_BUTTON1_PIN                               (1U)
#define BSP_BUTTON1_PORT                              (gpioPortB)

#define BSP_BUTTON_COUNT                              (2U)
#define BSP_BUTTON_INIT                               { { BSP_BUTTON0_PORT, BSP_BUTTON0_PIN }, { BSP_BUTTON1_PORT, BSP_BUTTON1_PIN } }
#define BSP_BUTTON_GPIO_DOUT                          (HAL_GPIO_DOUT_LOW)
#define BSP_BUTTON_GPIO_MODE                          (HAL_GPIO_MODE_INPUT)
#define HAL_BUTTON_COUNT                              (2U)
#define HAL_BUTTON_ENABLE                             { 0, 1 }
// [BUTTON]$

// $[CMU]
#define HAL_CLK_HFCLK_SOURCE                          (HAL_CLK_HFCLK_SOURCE_HFXO)
#define HAL_CLK_PLL_CONFIGURATION                     (HAL_CLK_PLL_CONFIGURATION_40MHZ)
#define HAL_CLK_EM01CLK_SOURCE                        (HAL_CLK_HFCLK_SOURCE_HFRCODPLL)
#define HAL_CLK_EM23CLK_SOURCE                        (HAL_CLK_LFCLK_SOURCE_LFRCO)
#define HAL_CLK_EM4CLK_SOURCE                         (HAL_CLK_LFCLK_SOURCE_LFRCO)
#define HAL_CLK_RTCCCLK_SOURCE                        (HAL_CLK_LFCLK_SOURCE_LFRCO)
#define HAL_CLK_WDOGCLK_SOURCE                        (HAL_CLK_LFCLK_SOURCE_LFRCO)
#define BSP_CLK_HFXO_CTUNE                            (133)
#define BSP_CLK_LFXO_PRESENT                          (1)
#define BSP_CLK_LFXO_INIT                              CMU_LFXOINIT_DEFAULT
#define BSP_CLK_LFXO_FREQ                             (32768U)
#define BSP_CLK_LFXO_CTUNE                            (79U)
#define HAL_CLK_LFXO_PRECISION                        (100UL)
// [CMU]$

// $[COEX]
// [COEX]$

// $[EMU]
// [EMU]$

// $[EXTFLASH]
// [EXTFLASH]$

// $[EZRADIOPRO]
// [EZRADIOPRO]$

// $[FEM]
// [FEM]$

// $[GPIO]
#define PORTIO_GPIO_SWV_PIN                           (3U)
#define PORTIO_GPIO_SWV_PORT                          (gpioPortA)

#define BSP_TRACE_SWO_PIN                             (3U)
#define BSP_TRACE_SWO_PORT                            (gpioPortA)

// [GPIO]$

// $[I2C0]
// [I2C0]$

// $[I2C1]
// [I2C1]$

// $[I2CSENSOR]
// [I2CSENSOR]$

// $[IADC0]
// [IADC0]$

// $[IOEXP]
// [IOEXP]$

// $[LED]
// [LED]$

// $[LETIMER0]
// [LETIMER0]$

// $[LFXO]
// [LFXO]$

// $[MODEM]
// [MODEM]$

// $[PA]
#define HAL_PA_ENABLE                                 (1)

#define HAL_PA_CURVE_HEADER                            "pa_curves_efr32.h"
#define HAL_PA_POWER                                  (252U)
#define HAL_PA_RAMP                                   (10UL)
#define BSP_PA_VOLTAGE                                (3300U)
#define HAL_PA_SELECTION                              (HAL_PA_SELECTION_2P4_MP)
// [PA]$

// $[PORTIO]
// [PORTIO]$

// $[PRS]
#define PORTIO_PRS_ASYNCH4_PIN                        (0U)
#define PORTIO_PRS_ASYNCH4_PORT                       (gpioPortA)

// [PRS]$

// $[PTI]
#define PORTIO_PTI_DFRAME_PIN                         (5U)
#define PORTIO_PTI_DFRAME_PORT                        (gpioPortC)

#define PORTIO_PTI_DOUT_PIN                           (4U)
#define PORTIO_PTI_DOUT_PORT                          (gpioPortC)

#define HAL_PTI_ENABLE                                (1)

#define BSP_PTI_DFRAME_PIN                            (5U)
#define BSP_PTI_DFRAME_PORT                           (gpioPortC)

#define BSP_PTI_DOUT_PIN                              (4U)
#define BSP_PTI_DOUT_PORT                             (gpioPortC)

#define HAL_PTI_MODE                                  (HAL_PTI_MODE_UART)
#define HAL_PTI_BAUD_RATE                             (1600000UL)
// [PTI]$

// $[SERIAL]
#define BSP_SERIAL_APP_PORT                           (HAL_SERIAL_PORT_USART0)
#define HAL_SERIAL_RXWAKE_ENABLE                      (0)
#define HAL_SERIAL_IDLE_WAKE_ENABLE                   (1)
#define HAL_SERIAL_USART0_ENABLE                      (0)
#define HAL_SERIAL_USART1_ENABLE                      (0)
#define HAL_SERIAL_USART2_ENABLE                      (0)
#define BSP_SERIAL_APP_TX_PIN                         (5U)
#define BSP_SERIAL_APP_TX_PORT                        (gpioPortA)

#define BSP_SERIAL_APP_RX_PIN                         (6U)
#define BSP_SERIAL_APP_RX_PORT                        (gpioPortA)

#define BSP_SERIAL_APP_CTS_PIN                        (2U)
#define BSP_SERIAL_APP_CTS_PORT                       (gpioPortD)

#define BSP_SERIAL_APP_RTS_PIN                        (1U)
#define BSP_SERIAL_APP_RTS_PORT                       (gpioPortC)

#define HAL_SERIAL_APP_BAUD_RATE                      (115200UL)
#define HAL_SERIAL_APP_FLOW_CONTROL                   (HAL_USART_FLOW_CONTROL_HWUART)
#define HAL_SERIAL_APP_RXSTOP                         (16UL)
#define HAL_SERIAL_APP_RXSTART                        (16UL)
#define HAL_SERIAL_APP_TX_QUEUE_SIZE                  (128UL)
#define HAL_SERIAL_APP_RX_QUEUE_SIZE                  (128UL)
// [SERIAL]$

// $[SPIDISPLAY]
#define HAL_SPIDISPLAY_ENABLE                         (1)

#define BSP_SPIDISPLAY_CS_PIN                         (3U)
#define BSP_SPIDISPLAY_CS_PORT                        (gpioPortC)

#define BSP_SPIDISPLAY_ENABLE_PIN                     (4U)
#define BSP_SPIDISPLAY_ENABLE_PORT                    (gpioPortD)

#define BSP_SPIDISPLAY_EXTCOMIN_PIN                   (0U)
#define BSP_SPIDISPLAY_EXTCOMIN_PORT                  (gpioPortA)

#define BSP_SPIDISPLAY_EXTCOMIN_PIN                   (0U)
#define BSP_SPIDISPLAY_EXTCOMIN_PORT                  (gpioPortA)

#define BSP_SPIDISPLAY_DISPLAY                        (HAL_DISPLAY_SHARP_LS013B7DH03)
#define BSP_SPIDISPLAY_USART                          (HAL_SPI_PORT_USART2)
#define HAL_SPIDISPLAY_EXTMODE_EXTCOMIN               (1)
#define HAL_SPIDISPLAY_EXTMODE_SPI                    (0)
#define HAL_SPIDISPLAY_EXTCOMIN_USE_CALLBACK          (1)
#define HAL_SPIDISPLAY_EXTCOMIN_CALLBACK               rtcIntCallbackRegister
#define HAL_SPIDISPLAY_EXTCOMIN_USE_PRS               (0)
#define BSP_SPIDISPLAY_EXTCOMIN_CHANNEL               (4)
#define BSP_SPIDISPLAY_MOSI_PIN                       (0U)
#define BSP_SPIDISPLAY_MOSI_PORT                      (gpioPortC)

#define BSP_SPIDISPLAY_MISO_PIN                       (1U)
#define BSP_SPIDISPLAY_MISO_PORT                      (gpioPortC)

#define BSP_SPIDISPLAY_CLK_PIN                        (2U)
#define BSP_SPIDISPLAY_CLK_PORT                       (gpioPortC)

#define HAL_SPIDISPLAY_FREQUENCY                      (1000000UL)
// [SPIDISPLAY]$

// $[SPINCP]
// [SPINCP]$

// $[TIMER0]
// [TIMER0]$

// $[TIMER1]
// [TIMER1]$

// $[TIMER2]
// [TIMER2]$

// $[TIMER3]
// [TIMER3]$

// $[UARTNCP]
// [UARTNCP]$

// $[USART0]
#define PORTIO_USART0_CTS_PIN                         (2U)
#define PORTIO_USART0_CTS_PORT                        (gpioPortD)

#define PORTIO_USART0_RTS_PIN                         (1U)
#define PORTIO_USART0_RTS_PORT                        (gpioPortC)

#define PORTIO_USART0_RX_PIN                          (6U)
#define PORTIO_USART0_RX_PORT                         (gpioPortA)

#define PORTIO_USART0_TX_PIN                          (5U)
#define PORTIO_USART0_TX_PORT                         (gpioPortA)

#define HAL_USART0_ENABLE                             (1)

#define BSP_USART0_TX_PIN                             (5U)
#define BSP_USART0_TX_PORT                            (gpioPortA)

#define BSP_USART0_RX_PIN                             (6U)
#define BSP_USART0_RX_PORT                            (gpioPortA)

#define BSP_USART0_CTS_PIN                            (2U)
#define BSP_USART0_CTS_PORT                           (gpioPortD)

#define BSP_USART0_RTS_PIN                            (1U)
#define BSP_USART0_RTS_PORT                           (gpioPortC)

#define HAL_USART0_BAUD_RATE                          (115200UL)
#define HAL_USART0_FLOW_CONTROL                       (HAL_USART_FLOW_CONTROL_HWUART)
#define HAL_USART0_RXSTOP                             (16UL)
#define HAL_USART0_RXSTART                            (16UL)
#define HAL_USART0_TX_QUEUE_SIZE                      (128UL)
#define HAL_USART0_RX_QUEUE_SIZE                      (128UL)
// [USART0]$

// $[USART1]
// [USART1]$

// $[USART2]
#define PORTIO_USART2_CLK_PIN                         (2U)
#define PORTIO_USART2_CLK_PORT                        (gpioPortC)

#define PORTIO_USART2_CS_PIN                          (3U)
#define PORTIO_USART2_CS_PORT                         (gpioPortC)

#define PORTIO_USART2_RX_PIN                          (1U)
#define PORTIO_USART2_RX_PORT                         (gpioPortC)

#define PORTIO_USART2_TX_PIN                          (0U)
#define PORTIO_USART2_TX_PORT                         (gpioPortC)

#define HAL_USART2_ENABLE                             (1)

#define BSP_USART2_MOSI_PIN                           (0U)
#define BSP_USART2_MOSI_PORT                          (gpioPortC)

#define BSP_USART2_MISO_PIN                           (1U)
#define BSP_USART2_MISO_PORT                          (gpioPortC)

#define BSP_USART2_CLK_PIN                            (2U)
#define BSP_USART2_CLK_PORT                           (gpioPortC)

#define BSP_USART2_CS_PIN                             (3U)
#define BSP_USART2_CS_PORT                            (gpioPortC)

#define HAL_USART2_FREQUENCY                          (1000000UL)
// [USART2]$

// $[VCOM]
#define HAL_VCOM_ENABLE                               (1)

#define BSP_VCOM_ENABLE_PIN                           (3U)
#define BSP_VCOM_ENABLE_PORT                          (gpioPortD)

// [VCOM]$

// $[VUART]
// [VUART]$

// $[WDOG]
#define HAL_WDOG_ENABLE                               (1)

// [WDOG]$

#if defined(_SILICON_LABS_MODULE)
#include "sl_module.h"
#endif

#endif /* HAL_CONFIG_H */

